# struct LLVM::DIBuilder

- LLVM::DIBuilder
- Struct
- Value
- Object

##
Defined in:

##
Constructors

- .new(llvm_module : Module)

##
Instance Method Summary

- #create_auto_variable(scope, name, file, line, type, align_in_bits)
- #create_basic_type(name, size_in_bits, align_in_bits, encoding)
- #create_compile_unit(lang, file, dir, producer, optimized, flags, runtime_version)
- #create_enumeration_type(scope, name, file, line_number, size_in_bits, align_in_bits, elements, underlying_type)
- #create_enumerator(name, value)
- #create_expression(addr, length)
- #create_file(file, dir)
- #create_function(scope, name, linkage_name, file, line, composite_type, is_local_to_unit, is_definition, scope_line, flags, is_optimized, func)
- #create_lexical_block(scope, file, line, column)
- #create_member_type(scope, name, file, line, size_in_bits, align_in_bits, offset_in_bits, flags, ty)
- #create_parameter_variable(scope, name, argno, file, line, type)
- #create_pointer_type(pointee, size_in_bits, align_in_bits, name)
- #create_replaceable_composite_type(scope, name, file, line, context : Context)
- #create_struct_type(scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types)
- #create_subroutine_type(file, parameter_types)
- #end
- #get_or_create_array(elements : Array(LibLLVMExt::Metadata))
- #get_or_create_type_array(types : Array(LibLLVMExt::Metadata))
- #insert_declare_at_end(storage, var_info, expr, dl, block)
- #replace_temporary(from, to)
- #to_unsafe : LibLLVMExt::DIBuilder

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(llvm_module : Module) #

##
Instance Method Detail

def create_auto_variable(scope, name, file, line, type, align_in_bits) #
def create_basic_type(name, size_in_bits, align_in_bits, encoding) #
def create_compile_unit(lang, file, dir, producer, optimized, flags, runtime_version) #
def create_enumeration_type(scope, name, file, line_number, size_in_bits, align_in_bits, elements, underlying_type) #
def create_enumerator(name, value) #
def create_expression(addr, length) #
def create_file(file, dir) #
def create_function(scope, name, linkage_name, file, line, composite_type, is_local_to_unit, is_definition, scope_line, flags, is_optimized, func) #
def create_lexical_block(scope, file, line, column) #
def create_member_type(scope, name, file, line, size_in_bits, align_in_bits, offset_in_bits, flags, ty) #
def create_parameter_variable(scope, name, argno, file, line, type) #
def create_pointer_type(pointee, size_in_bits, align_in_bits, name) #
def create_replaceable_composite_type(scope, name, file, line, context : Context) #
def create_struct_type(scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types) #
def create_subroutine_type(file, parameter_types) #
def end #
def get_or_create_array(elements : Array(LibLLVMExt::Metadata)) #
def get_or_create_type_array(types : Array(LibLLVMExt::Metadata)) #
def insert_declare_at_end(storage, var_info, expr, dl, block) #
def replace_temporary(from, to) #
def to_unsafe : LibLLVMExt::DIBuilder #